from .utils.RealiBoxTestBiz import RealiBoxTestBiz
from .RealiBoxRequest import RealiBoxRequest
from .JsonPath.JsonPath import JsonPath
from .JsonPath.Assertion import Assertion


class RealiBoxTestBase(RealiBoxTestBiz):
    # 断言方法
    def assertion(self, value):
        return Assertion(self, value)

    # http请求方法
    def http_request(self, req_json):
        return RealiBoxRequest(self, req_json=req_json)

    # jsonpath解析
    def json_path(self, expr, json_obj=None):
        return JsonPath(self, expr, json_obj or self.current_response_object)

    def assert_many(self, *args):
        '''extract_assert的批量处理方法
        参数为多个元组， 元组内结果如extract_assert方法参数。
        注意：这是个批量处理方法，不返回提取结果，只能用与批量断言
        '''
        for i in args:
            self.extract_assert(*i)

    # 批量设置用例属性
    def set_many(self, *args):
        if not len(args) % 2 == 0:
            raise ValueError(''' set_many params error: 参数个数必须是偶数''')
        if len(args) < 2:
            return
        args_list = list(args)
        value, attr = [args_list.pop() for i in range(2)]
        # value是一个元组作为参数传递给 extract_assert
        if isinstance(value, tuple):
            val = self.extract_assert(*value)
        else:
            val = value
        if not attr == '_':
            setattr(self.V, attr, val)
        return self.set_many(*args_list)

    # 读取用例属性
    def get_attr(self, attr):
        return getattr(self.V, attr)










