import os
from loguru import logger as lg

# lg.remove(handler_id=None)  # 关闭控制台输出

business_log_dir = '.log'

if not os.path.exists(business_log_dir):
    os.makedirs(business_log_dir)

debug_log = os.path.join(business_log_dir, 'DEBUG.log')
info_log = os.path.join(business_log_dir, 'INFO.log')
error_log = os.path.join(business_log_dir, 'ERROR.log')
warn_log = os.path.join(business_log_dir, 'WARN.log')

lg.add(
    info_log,
    level="INFO",
    filter=lambda x: 'INFO' in str(x['level']).upper(),
    format="{time:YYYY-MM-DD at HH:mm:ss}|{level}|{function}|{thread}|{message}",
    rotation='0:00',
    enqueue=True,
    serialize=False,
    encoding="utf-8",
    retention="10 days",
)

lg.add(
    error_log,
    level="ERROR",
    filter=lambda x: 'ERROR' in str(x['level']).upper(),
    format="{time:YYYY-MM-DD at HH:mm:ss}|{level}|{function}|{thread}|{message}",
    rotation='0:00',
    enqueue=True,
    serialize=False,
    encoding="utf-8",
    retention="10 days"
)

lg.add(
    debug_log,
    level="DEBUG",
    filter=lambda x: 'DEBUG' in str(x['level']).upper(),
    format="{time:YYYY-MM-DD at HH:mm:ss}|{level}|{function}|{thread}|{message}",
    rotation='0:00',
    enqueue=True,
    serialize=False,
    encoding="utf-8",
    retention="10 days"
)

lg.add(
    warn_log,
    level="WARNING",
    filter=lambda x: 'WARNING' in str(x['level']).upper(),
    format="{time:YYYY-MM-DD at HH:mm:ss}|{level}|{function}|{thread}|{message}",
    rotation='0:00',
    enqueue=True,
    serialize=False,
    encoding="utf-8",
    retention="10 days"
)


