'''req_json加工
1、copy req_json 剔除最外层 file 字段提取 data 字段。剔除file字段。进行字符串模版匹配， 在合并file。
2、copy req_json
'''
from .sub_string_template import sub_string_template
import json


def req_json_machining(req_json, V):
    '''将req_json进行模版处理， 并生成用于请求的req_json、 用于记录流程的req_json_cp'''
    # 取出最外层的 file
    outer_file = req_json.pop('file') if 'file' in req_json else None
    # 取出 data
    data = req_json.pop('data') if 'data' in req_json else None

    # 对提取数据的req_json进行处理
    req_json_string = json.dumps(req_json, indent=2, ensure_ascii=False)
    rsub_string = sub_string_template(req_json_string, V)
    req_json = json.loads(rsub_string)
    # 将req_json复制一份用于保存 流程数据
    req_json_cp = req_json.copy()

    # 将data进行加工
    if data:
        # data为dict， 字符串模版匹配，匹配结果json赋值给req_json 和 req_json_cp
        if isinstance(data, dict):
            data_string = json.dumps(data, indent=2, ensure_ascii=False)
            dsub_string = sub_string_template(data_string, V)
            data_obj = data_obj_cp = json.loads(dsub_string)
        # data为非json， req_json.data直接取data， req_json_cp.data 取 str(type(data))
        else:
            data_obj = data
            data_obj_cp = str(type(data))

        # data 合并回req_json
        req_json['data'] = data_obj
        req_json_cp['data'] = data_obj_cp

    # 将 outer_file 合并回 req_json
    if outer_file:
        req_json_cp['file'] = str(type(outer_file))
        req_json['file'] = outer_file

    return req_json, req_json_cp










