'''请求服务端记录用例报告数据'''
import requests
import base64
from ..Cerebro import Cerebro
cerebro = Cerebro()


def save_case_report(case_item):
    '''保存用例结果报告'''
    requests.request(
        **{
            'url': 'http://172.16.101.107:7075/test_datas/case_report',
            'method': 'POST',
            'json': {
                'case_id': base64.b64encode(case_item.nodeid.encode()).decode(),
                'task_id': cerebro.task_id,
                'is_success': cerebro.current_is_success,
                'record_json': cerebro.current_case_json,
            },
        }
    )


def save_task_report(summary):
    '''保存任务结果报告'''
    requests.request(
        **{
            'url': 'http://172.16.101.107:7075/test_datas/task_report',
            'method': 'POST',
            'json': {
                'task_id': cerebro.task_id,
                'result': summary
            }
        }
    )


def case_collect_post(case_info):
    '''用例收集'''
    requests.request(
        **{
            'url': 'http://172.16.101.107:7075/test_datas/case_collect',
            'method': 'POST',
            'json': {
                'unique_code': case_info.unique_code,
                'case_name': case_info.case_name,
                'first_node_doc': case_info.first_node_doc,
                'second_node_doc': case_info.second_node_doc,
                'first_node': case_info.first_node,
                'second_node': case_info.second_node,
            }
        }
    )


def case_collect_list(unique_code):
    '''用例收集'''
    return requests.request(
        **{
            'url': 'http://172.16.101.107:7075/test_datas/case_collect',
            'method': 'GET',
            'json': {'unique_code': unique_code}
        }
    )

